from yixue import Configs
from yixue.Models import SiZhu, GaoNeng


def __calc__fang_xiang__(gn: GaoNeng, zhu: SiZhu):
    if gn.guanxi in ["合", "暗合", "半合"]:
        if zhu.text == gn.fangxiang:
            gn.sign = ""
        else:
            if gn.wei_zhi3 is None:
                if zhu.wei_zhi < gn.wei_zhi2:
                    gn.sign = "→"
                else:
                    gn.sign = "←"
            else:
                wz = gn.wei_zhi2
                if gn.fangxiang == gn.arg3:
                    wz = gn.wei_zhi3
                if zhu.wei_zhi < wz:
                    gn.sign = "→"
                else:
                    gn.sign = "←"


def fix_gao_neng(riyuan: str, zhu1: SiZhu, zhu2: SiZhu, zhu3: SiZhu, trigger: str = None):
    key = zhu1.text + zhu2.text
    if zhu3 is not None:
        key += zhu3.text
    try:
        if Configs.config_gaoneng_query.__contains__(key):
            infos = Configs.config_gaoneng_query[key]
            for info in infos:
                gn = GaoNeng()
                gn.arg1 = zhu1.text
                gn.arg2 = zhu2.text
                gn.wei_zhi1 = zhu1.wei_zhi
                gn.wei_zhi2 = zhu2.wei_zhi
                gn.wu_xing1 = zhu1.wu_xing
                gn.wu_xing2 = zhu2.wu_xing
                gn.shi_shen1 = zhu1.shi_shen
                gn.shi_shen2 = zhu2.shi_shen

                if zhu3 is not None:
                    gn.arg3 = zhu3.text
                    gn.wei_zhi3 = zhu3.wei_zhi
                    gn.wu_xing3 = zhu3.wu_xing
                    gn.shi_shen3 = zhu3.shi_shen
                gn.text = info["name"]
                gn.guanxi = info["guanxi"]
                gn.leibie = info["leibie"]
                gn.hehua = info["hehua"]
                gn.fangxiang = info["fangxiang"]
                if gn.guanxi in ["半合", "拱合", "三会"]:
                    gn.zengqiang_shishen = Configs.config_shishen[riyuan][gn.fangxiang]
                if gn.guanxi == "刑":
                    xing = Configs.get_value(Configs.config_gaoneng_xing, gn.text)
                    if xing is not None:
                        chus = xing["刑出"]
                        chongs = xing["刑冲"]
                        gn.xing_chu = ""
                        for chu in chus:
                            xing_shi_shen = Configs.get_value2(Configs.config_shishen, riyuan, chu)
                            gn.xing_chu += xing_shi_shen
                        gn.xing_chong = ""
                        for chong in chongs:
                            chong_shi_shen1 = Configs.get_value2(Configs.config_shishen, riyuan, chong[0])
                            chong_shi_shen2 = Configs.get_value2(Configs.config_shishen, riyuan, chong[1])
                            gn.xing_chong += chong_shi_shen1 + chong_shi_shen2 + "冲"
                gn.tip = info["tip"]
                __calc__fang_xiang__(gn, zhu1)
                if trigger is None:
                    zhu1.gaonengs.append(gn)
                else:
                    if not zhu1.trigger_gaonengs.__contains__(trigger):
                        zhu1.trigger_gaonengs[trigger] = []
                    lst = zhu1.trigger_gaonengs[trigger]
                    lst.append(gn)
    except Exception as e:
        print("error on :CalcGaoNeng.fix_gao_neng", e)
