import calendar
import datetime

from wx.dbTools import DBNongLi
from yixue import Configs
from yixue.Models import BaZi, LiuRi, SiZhu
from yixue.sizhu import CalcShenSha, CalcGaoNeng


def run(bazi: BaZi):
    riyuan = bazi.ri_gan.text
    for dayun in bazi.dayun:
        for liunian in dayun.liunian:
            start_date = datetime.datetime(year=liunian.year, month=1, day=1)
            start_gan_zhi = __get_start_gan_zhi_of_day__(liunian.year)
            if start_gan_zhi is None:
                continue

            for liuyue in liunian.liuyue:
                dt = calendar.monthrange(liunian.year, liuyue.month)
                max_day = dt[1]
                liuyue.liuri = []
                for day in range(1, max_day + 1):
                    end_date = datetime.datetime(year=liunian.year, month=liuyue.month, day=day)
                    dist = (end_date - start_date).days

                    lr = LiuRi()
                    lr.day = day
                    lr.nong_li = ""
                    lr.xing_qi = end_date.weekday()
                    lr.gan_text = __next_tiangan__(start_gan_zhi[0], dist)
                    lr.zhi_text = __next_dizhi__(start_gan_zhi[1], dist)
                    lr.trigger = dayun.gan_text + dayun.zhi_text + liunian.gan_text + liunian.zhi_text + liuyue.gan_text + liuyue.zhi_text + lr.gan_text + lr.zhi_text
                    lr.gan_zhu = SiZhu(lr.gan_text, Configs.const_liuri_gan)
                    lr.zhi_zhu = SiZhu(lr.zhi_text, Configs.const_liuri_zhi)
                    lr.gan_zhu.liuri_text = lr.gan_text + lr.zhi_text
                    lr.zhi_zhu.liuri_text = lr.gan_text + lr.zhi_text
                    lr.gan_zhu.dayun_text = dayun.gan_text + dayun.zhi_text
                    lr.zhi_zhu.dayun_text = dayun.gan_text + dayun.zhi_text
                    lr.gan_zhu.liunian_text = liunian.gan_text + liunian.zhi_text
                    lr.zhi_zhu.liunian_text = liunian.gan_text + liunian.zhi_text
                    lr.gan_zhu.liuyue_text = liuyue.gan_text + liuyue.zhi_text
                    lr.zhi_zhu.liuyue_text = liuyue.gan_text + liuyue.zhi_text
                    __fill_sizhu_data(lr.gan_zhu, riyuan, False)
                    __fill_sizhu_data(lr.zhi_zhu, riyuan, True)
                    liuyue.liuri.append(lr)


def __print_nong_li_data__():
    ss = DBNongLi.new_session()
    data = ss.query(DBNongLi).filter(DBNongLi.day == "初一")
    temp = {}
    for dt in data:
        year = dt.new_date.year
        month = dt.new_date.month
        day = dt.new_date.day
        obj = {
            "year": year,
            "month": month,
            "day": day,
            "nl_yue": dt.month,
            "nl_ri": dt.day,
            "real_year": dt.year
        }

        if not temp.__contains__(year):
            temp[year] = {}
        year_obj = temp[year]

        if not year_obj.__contains__(month):
            year_obj[month] = {}
        month_obj = year_obj[month]
        if year == dt.year:
            month_obj[day] = obj
        elif year < dt.year:
            if not temp[year - 1].__contains__(month):
                temp[year - 1] = {}
            year_obj = temp[year - 1]

            if not year_obj.__contains__(month):
                year_obj[month] = {}
            month_obj[day] = obj

    # print(temp)
    for year in temp.keys():
        year_obj = temp[year]
        print(year, ":{")
        for month in year_obj.keys():
            month_obj = year_obj[month]
            print("   ", month, ":{")
            for day in month_obj.keys():
                day_obj = month_obj[day]
                print("       ", day, ":", day_obj, ",")
            print("    },")

        print("},")

    ss.close()


def calc_gaoneng(bazi: BaZi):
    # 这边运算太久了，放本地去算，选了才计算
    return
    tgs = bazi.all_tian_gans()
    dzs = bazi.all_di_zhis()
    riyuan = bazi.ri_gan.text
    for dayun in bazi.dayun:
        for liunian in dayun.liunian:
            for liuyue in liunian.liuyue:
                for lr in liuyue.liuri:

                    # 流日天干 vs 原局天干
                    for tg in tgs:
                        CalcGaoNeng.fix_gao_neng(riyuan, lr.gan_zhu, tg, None)
                        CalcGaoNeng.fix_gao_neng(riyuan, tg, lr.gan_zhu, None, lr.trigger)

                    # 流月地支 vs 原局地支 3
                    for dz1 in dzs:
                        for dz2 in dzs:
                            if dz1.wei_zhi == dz2.wei_zhi:
                                continue
                            CalcGaoNeng.fix_gao_neng(riyuan, lr.zhi_zhu, dz1, dz2, )
                            CalcGaoNeng.fix_gao_neng(riyuan, dz1, dz2, lr.zhi_zhu, lr.trigger)
                            CalcGaoNeng.fix_gao_neng(riyuan, dz2, lr.zhi_zhu, dz1, lr.trigger)

                    # 流日地支 vs 原局地支 2
                    for dz in dzs:
                        CalcGaoNeng.fix_gao_neng(riyuan, lr.zhi_zhu, dz, None)
                        CalcGaoNeng.fix_gao_neng(riyuan, dz, lr.zhi_zhu, None, lr.trigger)

                    other_tgs = [liunian.gan_zhu, liuyue.gan_zhu]
                    other_dzs = [liunian.zhi_zhu, liuyue.zhi_zhu]
                    # 流年如果来自大运，还要和大运再做一次比对
                    if liunian.from_dayun:
                        other_tgs.append(dayun.gan_zhu)
                        other_dzs.append(dayun.zhi_zhu)

                    # 流日天干 vs 大运流年流月天干
                    for tg in other_tgs:
                        CalcGaoNeng.fix_gao_neng(riyuan, lr.gan_zhu, tg, None)
                        CalcGaoNeng.fix_gao_neng(riyuan, tg, lr.gan_zhu, None, lr.trigger)

                    # 流日地支 vs 大运流年流月地支 3
                    for dz1 in other_dzs:
                        for dz2 in dzs:
                            CalcGaoNeng.fix_gao_neng(riyuan, lr.zhi_zhu, dz1, dz2)
                            CalcGaoNeng.fix_gao_neng(riyuan, dz1, dz2, lr.zhi_zhu, lr.trigger)
                            CalcGaoNeng.fix_gao_neng(riyuan, dz2, lr.zhi_zhu, dz1, lr.trigger)

                    # 流日地支 vs 大运流年流月地支 2
                    for dz in other_dzs:
                        CalcGaoNeng.fix_gao_neng(riyuan, lr.zhi_zhu, dz, None)
                        CalcGaoNeng.fix_gao_neng(riyuan, dz, lr.zhi_zhu, None, lr.trigger)


def calc_shensha(bazi: BaZi):
    riyuan = bazi.ri_gan.text
    for dayun in bazi.dayun:
        for liunian in dayun.liunian:
            for liuyue in liunian.liuyue:
                for lr in liuyue.liuri:
                    CalcShenSha.__check_lu_shen__(lr.zhi_zhu, riyuan)
                    CalcShenSha.__check_yang_ren__(lr.zhi_zhu, riyuan)
                    CalcShenSha.__check_wen_chang__(lr.gan_zhu, lr.zhi_zhu)
                    CalcShenSha.__check_kui_gang__(lr.gan_zhu, lr.zhi_zhu)
                    CalcShenSha.__check_yi_ma__(bazi.nian_zhi, bazi.ri_zhi, [lr.zhi_zhu])
                    CalcShenSha.__check_tianluo_diwang__(bazi.nian_zhi, bazi.ri_zhi, [lr.zhi_zhu])
                    CalcShenSha.__check_tao_hua__(bazi.nian_zhi, bazi.ri_zhi, [lr.zhi_zhu])


def __fill_sizhu_data(sz: SiZhu, riyuan: str, is_dizhi: bool):
    sz.wu_xing = Configs.get_value(Configs.config_wuxing, sz.text)
    sz.shi_shen = Configs.get_value2(Configs.config_shishen, riyuan, sz.text)
    if is_dizhi:
        cang_gan = Configs.get_value(Configs.config_canggan, sz.text)
        sz.cang_gan1 = cang_gan[0]
        sz.cang_gan2 = cang_gan[1]
        sz.cang_gan3 = cang_gan[2]
        if sz.cang_gan1 is not None:
            sz.gan1_wu_xing = Configs.get_value(Configs.config_wuxing, sz.cang_gan1)
            sz.gan1_shi_shen = Configs.get_value2(Configs.config_shishen, riyuan, sz.cang_gan1)
        if sz.cang_gan2 is not None:
            sz.gan2_wu_xing = Configs.get_value(Configs.config_wuxing, sz.cang_gan2)
            sz.gan2_shi_shen = Configs.get_value2(Configs.config_shishen, riyuan, sz.cang_gan2)
        if sz.cang_gan3 is not None:
            sz.gan3_wu_xing = Configs.get_value(Configs.config_wuxing, sz.cang_gan3)
            sz.gan3_shi_shen = Configs.get_value2(Configs.config_shishen, riyuan, sz.cang_gan3)


def __get_start_gan_zhi_of_day__(year: int):
    data = Configs.get_value2(Configs.config_jie_qi, year, "一日")
    if data is not None and len(data) == 2:
        return [data[0], data[1]]
    else:
        return None


def __get_next_by_dist__(ary: [str], item: str, dist: int):
    result = None
    if ary.__contains__(item):
        index = ary.index(item)
        index += dist
        ln = len(ary)
        while index >= ln:
            index -= ln
        result = ary[index]
    return result


def __next_tiangan__(tiangan: str, dist: int):
    return __get_next_by_dist__(Configs.config_tiangan_list, tiangan, dist)


def __next_dizhi__(dizhi: str, dist: int):
    return __get_next_by_dist__(Configs.config_dizhi_list, dizhi, dist)
