from yixue import Configs
from yixue.Models import BaZi, LiuYue, SiZhu
from yixue.sizhu import CalcShenSha, CalcGaoNeng


def run(bazi: BaZi):
    riyuan = bazi.ri_gan.text
    for dayun in bazi.dayun:
        for ln in dayun.liunian:
            ln.liuyue = []
            start_gan_zhi = __get__start_gan_zhi__(ln.year)
            if start_gan_zhi is None:
                continue
            for month in range(1, 13):
                # 这里要注意，超过2098年的数据无法生成，会导致流年下没有对应的流月数据
                ly = LiuYue()
                ly.month = month
                dist = month
                ly.gan_text = __next_tiangan__(start_gan_zhi[0], dist)
                ly.zhi_text = __next_dizhi__(start_gan_zhi[1], dist)
                ly.jie_qi = Configs.config_jie_qi_list[month - 1]
                ly.jie_qi_date = Configs.get_value2(Configs.config_jie_qi, ln.year, ly.jie_qi)
                if ly.jie_qi_date is not None:
                    ly.jie_qi_date = str(ly.jie_qi_date).replace(".", "/")
                ly.trigger = dayun.gan_text + dayun.zhi_text + ln.gan_text + ln.zhi_text + ly.gan_text + ly.zhi_text
                ly.gan_zhu = SiZhu(ly.gan_text, Configs.const_liuyue_gan)
                ly.zhi_zhu = SiZhu(ly.zhi_text, Configs.const_liuyue_zhi)
                ly.gan_zhu.liuyue_text = ly.gan_text + ly.zhi_text
                ly.zhi_zhu.liuyue_text = ly.gan_text + ly.zhi_text
                ly.gan_zhu.dayun_text = dayun.gan_text + dayun.zhi_text
                ly.zhi_zhu.dayun_text = dayun.gan_text + dayun.zhi_text
                ly.gan_zhu.liunian_text = ln.gan_text + ln.zhi_text
                ly.zhi_zhu.liunian_text = ln.gan_text + ln.zhi_text
                __fill_sizhu_data(ly.gan_zhu, riyuan, False)
                __fill_sizhu_data(ly.zhi_zhu, riyuan, True)
                ln.liuyue.append(ly)


def calc_gaoneng(bazi: BaZi):
    # 这边运算太久了，放本地去算，选了才计算
    return
    tgs = bazi.all_tian_gans()
    dzs = bazi.all_di_zhis()
    riyuan = bazi.ri_gan.text
    for dayun in bazi.dayun:
        for liunian in dayun.liunian:
            for ly in liunian.liuyue:

                # 流月天干 vs 原局天干
                for tg in tgs:
                    CalcGaoNeng.fix_gao_neng(riyuan, ly.gan_zhu, tg, None)
                    CalcGaoNeng.fix_gao_neng(riyuan, tg, ly.gan_zhu, None, ly.trigger)

                # 流月地支 vs 原局地支 3
                for dz1 in dzs:
                    for dz2 in dzs:
                        if dz1.wei_zhi == dz2.wei_zhi:
                            continue
                        CalcGaoNeng.fix_gao_neng(riyuan, ly.zhi_zhu, dz1, dz2, )
                        CalcGaoNeng.fix_gao_neng(riyuan, dz1, dz2, ly.zhi_zhu, ly.trigger)
                        CalcGaoNeng.fix_gao_neng(riyuan, dz2, ly.zhi_zhu, dz1, ly.trigger)

                # 流月地支 vs 原局地支 2
                for dz in dzs:
                    CalcGaoNeng.fix_gao_neng(riyuan, ly.zhi_zhu, dz, None)
                    CalcGaoNeng.fix_gao_neng(riyuan, dz, ly.zhi_zhu, None, ly.trigger)

                other_tgs = [liunian.gan_zhu]
                other_dzs = [liunian.zhi_zhu]
                # 流年如果来自大运，还要和大运再做一次比对
                if liunian.from_dayun:
                    other_tgs.append(dayun.gan_zhu)
                    other_dzs.append(dayun.zhi_zhu)

                # 流月天干 vs 大运流年天干
                for tg in other_tgs:
                    CalcGaoNeng.fix_gao_neng(riyuan, ly.gan_zhu, tg, None)
                    CalcGaoNeng.fix_gao_neng(riyuan, tg, ly.gan_zhu, None, ly.trigger)

                # 流月地支 vs 大运流年地支 3
                for dz1 in other_dzs:
                    for dz2 in dzs:
                        CalcGaoNeng.fix_gao_neng(riyuan, ly.zhi_zhu, dz1, dz2)
                        CalcGaoNeng.fix_gao_neng(riyuan, dz1, dz2, ly.zhi_zhu, ly.trigger)
                        CalcGaoNeng.fix_gao_neng(riyuan, dz2, ly.zhi_zhu, dz1, ly.trigger)

                # 流月地支 vs 大运流年地支 2
                for dz in other_dzs:
                    CalcGaoNeng.fix_gao_neng(riyuan, ly.zhi_zhu, dz, None)
                    CalcGaoNeng.fix_gao_neng(riyuan, dz, ly.zhi_zhu, None, ly.trigger)


def calc_shen_sha(bazi: BaZi):
    riyuan = bazi.ri_gan.text
    for dayun in bazi.dayun:
        for liunian in dayun.liunian:
            for ly in liunian.liuyue:
                CalcShenSha.__check_lu_shen__(ly.zhi_zhu, riyuan)
                CalcShenSha.__check_yang_ren__(ly.zhi_zhu, riyuan)
                CalcShenSha.__check_wen_chang__(ly.gan_zhu, ly.zhi_zhu)
                CalcShenSha.__check_kui_gang__(ly.gan_zhu, ly.zhi_zhu)
                CalcShenSha.__check_yi_ma__(bazi.nian_zhi, bazi.ri_zhi, [ly.zhi_zhu])
                CalcShenSha.__check_tianluo_diwang__(bazi.nian_zhi, bazi.ri_zhi, [ly.zhi_zhu])
                CalcShenSha.__check_tao_hua__(bazi.nian_zhi, bazi.ri_zhi, [ly.zhi_zhu])


def __fill_sizhu_data(sz: SiZhu, riyuan: str, is_dizhi: bool):
    sz.wu_xing = Configs.get_value(Configs.config_wuxing, sz.text)
    sz.shi_shen = Configs.get_value2(Configs.config_shishen, riyuan, sz.text)
    if is_dizhi:
        cang_gan = Configs.get_value(Configs.config_canggan, sz.text)
        sz.cang_gan1 = cang_gan[0]
        sz.cang_gan2 = cang_gan[1]
        sz.cang_gan3 = cang_gan[2]
        if sz.cang_gan1 is not None:
            sz.gan1_wu_xing = Configs.get_value(Configs.config_wuxing, sz.cang_gan1)
            sz.gan1_shi_shen = Configs.get_value2(Configs.config_shishen, riyuan, sz.cang_gan1)
        if sz.cang_gan2 is not None:
            sz.gan2_wu_xing = Configs.get_value(Configs.config_wuxing, sz.cang_gan2)
            sz.gan2_shi_shen = Configs.get_value2(Configs.config_shishen, riyuan, sz.cang_gan2)
        if sz.cang_gan3 is not None:
            sz.gan3_wu_xing = Configs.get_value(Configs.config_wuxing, sz.cang_gan3)
            sz.gan3_shi_shen = Configs.get_value2(Configs.config_shishen, riyuan, sz.cang_gan3)


def __get__start_gan_zhi__(year: int):
    result = None
    info = Configs.get_value(Configs.config_jie_qi, year)
    if info is not None:
        mData = info["一月"]
        result = [mData[0], mData[1]]
    return result


def __get_next_by_dist__(ary: [str], item: str, dist: int):
    result = None
    if ary.__contains__(item):
        index = ary.index(item)
        index += dist
        ln = len(ary)
        while index >= ln:
            index -= ln
        result = ary[index]
    return result


def __next_tiangan__(tiangan: str, dist: int):
    return __get_next_by_dist__(Configs.config_tiangan_list, tiangan, dist)


def __next_dizhi__(dizhi: str, dist: int):
    return __get_next_by_dist__(Configs.config_dizhi_list, dizhi, dist)
