from wx.dbTools import DBWanNianLi
from yixue import Configs
from yixue.Models import SiZhuCheckResult

shichen_ary = [23, 1, 3, 5, 7, 9, 11, 13, 15, 17, 19, 21]


def run(niangan: str, nianzhi: str, yuegan: str, yuezhi: str, rigan: str, rizhi: str, shigan: str, shizhi: str):
    result = SiZhuCheckResult()

    quy1 = DBWanNianLi.query_first_by(nian_gan=niangan, nian_zhi=nianzhi)
    if quy1 is None:
        result.error = True
        dt_nians = DBWanNianLi.query_by(nian_gan=niangan)
        for dt_nian in dt_nians:
            if not result.adv_nian.__contains__(dt_nian.nian_zhi):
                result.adv_nian.append(dt_nian.nian_zhi)
    else:
        # 到这里年对了
        quy2 = DBWanNianLi.query_first_by(nian_gan=niangan, nian_zhi=nianzhi, yue_gan=yuegan, yue_zhi=yuezhi)
        if quy2 is None:
            result.error = True
            dt_yues = DBWanNianLi.query_by(nian_gan=niangan, nian_zhi=nianzhi, yue_gan=yuegan)
            for dt_yue in dt_yues:
                if not result.adv_yue.__contains__(dt_yue.yue_zhi):
                    result.adv_yue.append(dt_yue.yue_zhi)
        else:
            # 到这里月对了
            quy3 = DBWanNianLi.query_first_by(nian_gan=niangan, nian_zhi=nianzhi, yue_gan=yuegan, yue_zhi=yuezhi,
                                              ri_gan=rigan, ri_zhi=rizhi)
            if quy3 is None:
                result.error = True
                dt_ris = DBWanNianLi.query_by(nian_gan=niangan, nian_zhi=nianzhi, yue_gan=yuegan, ri_gan=rigan)
                for dt_ri in dt_ris:
                    if not result.adv_ri.__contains__(dt_ri.ri_zhi):
                        result.adv_ri.append(dt_ri.ri_zhi)
            else:
                # 到这里日对了
                time_ok = False
                correct_time = -1
                if shigan is not None and shizhi is not None:
                    start_tiangan = __get_tiangan_start_of_hour__(rigan)
                    start_dizhi = "子"
                    last_tiangan = start_tiangan
                    last_dizhi = start_dizhi
                    result.error = True
                    for index, shichen in enumerate(shichen_ary):
                        if last_tiangan == shigan and last_dizhi == shizhi:
                            result.error = False
                            time_ok = True
                            correct_time = shichen
                            break
                        last_tiangan = __next_tiangan__(last_tiangan, 1)
                        last_dizhi = __next_dizhi__(last_dizhi, 1)

                    if result.error:
                        last_tiangan = start_tiangan
                        last_dizhi = start_dizhi
                        for index, shichen in enumerate(shichen_ary):
                            if last_tiangan == shigan and last_dizhi != shizhi:
                                if not result.adv_shi.__contains__(last_dizhi):
                                    result.adv_shi.append(last_dizhi)
                            last_tiangan = __next_tiangan__(last_tiangan, 1)
                            last_dizhi = __next_dizhi__(last_dizhi, 1)
                else:
                    time_ok = True

                if time_ok:
                    # 到这里时对了
                    quy4 = DBWanNianLi.query_by(nian_gan=niangan, nian_zhi=nianzhi, yue_gan=yuegan, yue_zhi=yuezhi,
                                                ri_gan=rigan, ri_zhi=rizhi)
                    for dt in quy4:
                        if correct_time == -1:
                            key = str(dt.nian) + "-" + str(dt.yue) + "-" + str(dt.ri)
                            if not result.adv_date.__contains__(key):
                                result.adv_date.append(key)
                        else:
                            key = str(dt.nian) + "-" + str(dt.yue) + "-" + str(dt.ri) + " " + str(correct_time) + ":00"
                            if not result.adv_date.__contains__(key):
                                result.adv_date.append(key)
    return result


def __get_tiangan_start_of_hour__(riyuan: str):
    if riyuan == "甲" or riyuan == "己":
        return "甲"
    if riyuan == "乙" or riyuan == "庚":
        return "丙"
    if riyuan == "丙" or riyuan == "辛":
        return "戊"
    if riyuan == "丁" or riyuan == "壬":
        return "庚"
    if riyuan == "戊" or riyuan == "癸":
        return "壬"


def __get_next_by_dist__(ary: [str], item: str, dist: int):
    result = None
    if ary.__contains__(item):
        index = ary.index(item)
        index += dist
        ln = len(ary)
        while index >= ln:
            index -= ln
        result = ary[index]
    return result


def __next_tiangan__(tiangan: str, dist: int):
    return __get_next_by_dist__(Configs.config_tiangan_list, tiangan, dist)


def __next_dizhi__(dizhi: str, dist: int):
    return __get_next_by_dist__(Configs.config_dizhi_list, dizhi, dist)
