from yixue import Configs
from yixue.Models import SiZhu, BaZi, GaoNeng


def __has_gaoneng_in_dizhi(gn_text: str, bazi: BaZi):
    result = False
    if gn_text is not None:
        for dz in bazi.all_di_zhis():  # type: SiZhu
            for gn in dz.gaonengs:  # type: GaoNeng
                if gn.text == gn_text:
                    result = True
                    break
            if result:
                break
    return result


def is_muku_open(zhu: SiZhu, bazi: BaZi):
    result = False
    if Configs.config_muku.__contains__(zhu.text):
        info = Configs.config_muku[zhu.text]
        if __has_gaoneng_in_dizhi(info["lock"], bazi):
            # 锁库
            # 方案1，自刑开库
            result = __has_gaoneng_in_dizhi(info["zixing"], bazi)
            if result is False:
                # 方案2，拱合开库
                result = __has_gaoneng_in_dizhi(info["gonghe"], bazi)
                if result is False:
                    # 方案3，三会开库
                    result = __has_gaoneng_in_dizhi(info["sanhui"], bazi)
                    if result is False:
                        # 方案4，暗合+冲开库
                        rt1 = __has_gaoneng_in_dizhi(info["anhe"], bazi)
                        if rt1 is True:
                            result = __has_gaoneng_in_dizhi(info["chong"], bazi)
        else:
            # 未锁库，可以直接冲开
            if __has_gaoneng_in_dizhi(info["chong"], bazi):
                result = True
    return result
