import datetime

from yixue import Configs
from yixue.Models import BaZi, DaYun, LiuNian, ZhenDuanItem, GaoNeng, SiZhu


# 找今年对应的大运，往后看三年
# 如果跨大运，就看下一个大运，反正凑满3年
# 大运只看事业，年份的姻缘到姻缘板块看

def run(bazi: BaZi):
    cur = datetime.datetime.now()
    # cur.year
    dayun_list = []
    liu_nian_list = []
    jianyi = []
    cankao = []
    __find_dayun_liunian__(cur.year, bazi, dayun_list, liu_nian_list)
    __resolve_data__(dayun_list, liu_nian_list, jianyi, cankao, bazi)
    bazi.zhenduan.dayun.jianyi = jianyi
    bazi.zhenduan.dayun.cankao = cankao


def __resolve_data__(dayun_list: [DaYun], liunian_list: [LiuNian], jianyi: [], cankao: [], bazi: BaZi):
    last_dayun = None
    count = 0
    for index, dayun in enumerate(dayun_list):
        if last_dayun != dayun:
            __about_dayun__(dayun, jianyi, cankao, bazi, count)
            count += 1
        liunian = liunian_list[index]
        __about_liunian__(liunian, jianyi, cankao, bazi)
        last_dayun = dayun


def __about_dayun__(dayun: DaYun, jianyi: [], cankao: [], bazi: BaZi, count: int):
    if not dayun.is_dayun:
        return
    full_gan_shishen = __get_shishen_full_name__(dayun.gan_zhu.shi_shen)
    full_zhi_shishen = __get_shishen_full_name__(dayun.zhi_zhu.shi_shen)
    content = ""
    if count == 0:
        content += "大运走"
    else:
        content += "\n\n下个大运走"
    content += full_gan_shishen + full_zhi_shishen + "运(" + str(dayun.start_year) + " - " + str(
        dayun.end_year) + ")，"
    tip1 = Configs.get_value(Configs.config_zhenduan_dayun, dayun.gan_zhu.shi_shen)
    tip2 = Configs.get_value(Configs.config_zhenduan_dayun, dayun.zhi_zhu.shi_shen)
    if tip1 is not None and tip2 is not None:
        content += tip1 + "同时" + tip2
    item = ZhenDuanItem(0, content)
    item.set_selected(True)
    jianyi.append(item)

    __about_he__(dayun.gan_zhu, bazi, jianyi, cankao)
    __about_he__(dayun.zhi_zhu, bazi, jianyi, cankao)
    __about_an_he__(dayun.gan_zhu, bazi, jianyi, cankao)
    __about_an_he__(dayun.zhi_zhu, bazi, jianyi, cankao)
    __about_chong__(dayun.gan_zhu, bazi, jianyi, cankao)
    __about_chong__(dayun.zhi_zhu, bazi, jianyi, cankao)
    __about_xing__(dayun.gan_zhu, bazi, jianyi, cankao)
    __about_xing__(dayun.zhi_zhu, bazi, jianyi, cankao)
    __about_chuan__(dayun.gan_zhu, bazi, jianyi, cankao)
    __about_chuan__(dayun.zhi_zhu, bazi, jianyi, cankao)


def __about_liunian__(liunian: LiuNian, jianyi: [], cankao: [], bazi: BaZi):
    full_gan_shishen = __get_shishen_full_name__(liunian.gan_zhu.shi_shen)
    full_zhi_shishen = __get_shishen_full_name__(liunian.zhi_zhu.shi_shen)
    content = "\n" + str(liunian.year) + " " + liunian.gan_text + liunian.zhi_text + "年，"
    content += "以" + full_gan_shishen + full_zhi_shishen + "运为主，"
    tip1 = Configs.get_value(Configs.config_zhenduan_dayun, liunian.gan_zhu.shi_shen)
    tip2 = Configs.get_value(Configs.config_zhenduan_dayun, liunian.zhi_zhu.shi_shen)
    if tip1 is not None and tip2 is not None:
        content += tip1 + "同时" + tip2

    item = ZhenDuanItem(0, content)
    item.set_selected(True)
    jianyi.append(item)
    __about_he__(liunian.gan_zhu, bazi, jianyi, cankao)
    __about_he__(liunian.zhi_zhu, bazi, jianyi, cankao)
    __about_an_he__(liunian.gan_zhu, bazi, jianyi, cankao)
    __about_an_he__(liunian.zhi_zhu, bazi, jianyi, cankao)
    __about_chong__(liunian.gan_zhu, bazi, jianyi, cankao)
    __about_chong__(liunian.zhi_zhu, bazi, jianyi, cankao)
    __about_xing__(liunian.gan_zhu, bazi, jianyi, cankao)
    __about_xing__(liunian.zhi_zhu, bazi, jianyi, cankao)
    __about_chuan__(liunian.gan_zhu, bazi, jianyi, cankao)
    __about_chuan__(liunian.zhi_zhu, bazi, jianyi, cankao)


def __about_he__(sz: SiZhu, bazi: BaZi, jianyi: [], cankao: []):
    ct_he = 0
    more_shishen = ""
    # 高能
    for gn in sz.gaonengs:
        if gn.guanxi == "合":
            __do_check__(gn, bazi, Configs.config_gaoneng_he, jianyi, cankao)
            ct_he += 1
            more_shishen = gn.shi_shen2
    if ct_he > 1:
        __check_zheng_he__(sz.shi_shen, more_shishen, jianyi, cankao)


def __about_an_he__(sz: SiZhu, bazi: BaZi, jianyi: [], cankao: []):
    for gn in sz.gaonengs:
        if gn.guanxi == "暗合":
            __do_check__(gn, bazi, Configs.config_gaoneng_anhe, jianyi, cankao)


def __about_chong__(sz: SiZhu, bazi: BaZi, jianyi: [], cankao: []):
    for gn in sz.gaonengs:
        if gn.guanxi == "冲":
            __do_check__(gn, bazi, Configs.config_gaoneng_chong, jianyi, cankao)


def __about_xing__(sz: SiZhu, bazi: BaZi, jianyi: [], cankao: []):
    for gn in sz.gaonengs:
        if gn.guanxi == "刑":
            __do_check_xing__(gn, bazi, jianyi, cankao)


def __about_chuan__(sz: SiZhu, bazi: BaZi, jianyi: [], cankao: []):
    for gn in sz.gaonengs:
        if gn.guanxi == "穿":
            __do_check__(gn, bazi, Configs.config_gaoneng_chuan, jianyi, cankao)


def __check_zheng_he__(single: str, more: str, jianyi: [], cankao: []):
    tip = Configs.get_value2(Configs.config_zheng_he, single, more)
    if tip is not None:
        item = ZhenDuanItem(0, tip)
        item.set_selected(True)
        jianyi.append(item)
    else:
        print("争合：", single, more, "找不到对一个的描述")


def __do_check__(gn: GaoNeng, bazi: BaZi, data_src: {}, jianyi: [], cankao: []):
    data = Configs.get_value(data_src, gn.shi_shen1 + gn.shi_shen2)
    if data is None:
        data = Configs.get_value(data_src, gn.shi_shen2 + gn.shi_shen1)
    if data is not None:
        for dt in data:
            jiedu = dt["解读"]

            if gn.guanxi == "冲":
                power1 = __get_power__(gn.shi_shen1, bazi)
                power2 = __get_power__(gn.shi_shen2, bazi)
                tag = "平"
                if power1 > power2 * 2:
                    tag = "胜"
                elif power1 * 2 < power2:
                    tag = "负"
                jiedu += dt[tag]

            full_name1 = __get_shishen_full_name__(gn.shi_shen1)
            full_name2 = __get_shishen_full_name__(gn.shi_shen2)
            content = full_name1 + gn.guanxi + full_name2 + "，" + jiedu

            # if gn.guanxi in ["穿"]:
            #     zhu1 = __get_zhu_by_weizhi__(gn.wei_zhi1, bazi)
            #     other_text = __get_baohuzhe_in_zhu__(zhu1)
            #     if other_text is None:
            #         zhu2 = __get_zhu_by_weizhi__(gn.wei_zhi2, bazi)
            #         other_text = __get_baohuzhe_in_zhu__(zhu2)
            #     if other_text is not None:
            #         other_wuxing = Configs.get_value(Configs.config_wuxing, other_text)
            #         content += "(受" + other_text + other_wuxing + "的保护，负面的影响会被削弱)"

            item = ZhenDuanItem(0, content)
            item.key = gn.text

            if dt["类别"] == "建议":
                item.set_selected(True)
                jianyi.append(item)
            else:
                cankao.append(item)
    else:
        print("没找到匹配的关系在：", gn.shi_shen1 + gn.shi_shen2, gn.guanxi)


def __do_check_xing__(gn: GaoNeng, bazi: BaZi, jianyi: [], cankao: []):
    data = Configs.get_value(Configs.config_gaoneng_xing, gn.text)
    if data is not None:
        content = ""
        jie_fang = ""
        for chu in data["刑出"]:
            chu_shishen = Configs.get_value2(Configs.config_shishen, bazi.ri_gan.text, chu)
            full_name = __get_shishen_full_name__(chu_shishen)
            jie_fang += full_name
            if chu_shishen in ["官", "杀"]:
                content += full_name + "被刑，容易被目标吊着，总是差一点能够到。"
            elif chu_shishen in ["印", "枭"]:
                content += full_name + "被刑，得到的帮助都有代价，甚至与自身深度绑定。"
            elif chu_shishen in ["财", "才"]:
                content += full_name + "被刑，需要持续的投入财富、精力，持续的输血。"
            elif chu_shishen in ["食", "伤"]:
                content += full_name + "被刑，有力没处使，甚至感觉怀才不遇，情绪深陷其中。"
            elif chu_shishen in ["比", "劫"]:
                content += full_name + "被刑，自身、朋友、团队都被深度绑定，陷入漩涡。"

        # chong = data["刑冲"][0]
        # chong_shishen1 = Configs.get_value2(Configs.config_shishen, bazi.ri_gan.text, chong[0])
        # chong_shishen2 = Configs.get_value2(Configs.config_shishen, bazi.ri_gan.text, chong[1])
        # chong_data = Configs.get_value(Configs.config_gaoneng_chong, chong_shishen1 + chong_shishen2)
        # for cd in chong_data:
        #     jiedu = cd["解读"]
        #     power1 = __get_power__(chong_shishen1, bazi)
        #     power2 = __get_power__(chong_shishen2, bazi)
        #     tag = "平"
        #     if power1 > power2 * 2:
        #         tag = "胜"
        #     elif power1 * 2 < power2:
        #         tag = "负"
        #     jiedu += cd[tag]
        #     content += jiedu

        # zhu1 = __get_zhu_by_weizhi__(gn.wei_zhi1, bazi)
        # other_text = __get_baohuzhe_in_zhu__(zhu1)
        # if other_text is None:
        #     zhu2 = __get_zhu_by_weizhi__(gn.wei_zhi2, bazi)
        #     other_text = __get_baohuzhe_in_zhu__(zhu2)
        # if other_text is not None:
        #     other_wuxing = Configs.get_value(Configs.config_wuxing, other_text)
        #     content += "(受" + other_text + other_wuxing + "的保护，负面影响会被削弱)"

        item = ZhenDuanItem(0, content)
        item.key = gn.text
        item.set_selected(True)
        jianyi.append(item)

    else:
        print("没找到匹配的关系在：", gn.text)


def __get_zhu_by_weizhi__(weizhi: int, bazi: BaZi):
    if weizhi == Configs.const_nian_gan:
        return bazi.nian_gan
    if weizhi == Configs.const_yue_gan:
        return bazi.yue_gan
    if weizhi == Configs.const_ri_gan:
        return bazi.ri_gan
    if weizhi == Configs.const_shi_gan:
        return bazi.shi_gan
    if weizhi == Configs.const_nian_zhi:
        return bazi.nian_zhi
    if weizhi == Configs.const_yue_zhi:
        return bazi.yue_zhi
    if weizhi == Configs.const_ri_zhi:
        return bazi.ri_zhi
    if weizhi == Configs.const_shi_zhi:
        return bazi.shi_zhi


def __get_baohuzhe_in_zhu__(zhu: SiZhu):
    result = None
    self_text = zhu.text
    for gn in zhu.gaonengs:
        if gn.guanxi == "合":
            result = str(gn.text).replace("合", "").replace(self_text, "")
            break
        elif gn.guanxi == "暗合":
            result = str(gn.text).replace("暗合", "").replace(self_text, "")
            break
    return result


def __get_power__(shishen: str, bazi: BaZi):
    step = bazi.power_steps[shishen]
    amount = bazi.counter.power_raw[shishen]
    return round(step * amount, 0)


def __find_dayun_liunian__(year: int, bazi: BaZi, dayun_list: [DaYun], liunian_list: [LiuNian]):
    target_dayun = None
    target_dayun_index = -1
    for index, dayun in enumerate(bazi.dayun):
        if dayun.start_year <= year and year <= dayun.end_year:
            target_dayun = dayun
            target_dayun_index = index
            break

    if target_dayun is not None:
        target_liunian_index = -1
        target_liunian = None
        for index, liunian in enumerate(target_dayun.liunian):
            if liunian.year == year:
                target_liunian = liunian
                target_liunian_index = index
                break
        if target_liunian is not None:
            dayun_list.append(target_dayun)
            liunian_list.append(target_liunian)
            while len(dayun_list) < 3:
                if target_liunian_index < len(target_dayun.liunian) - 1:
                    target_liunian_index += 1
                    dayun_list.append(target_dayun)
                    liunian_list.append(target_dayun.liunian[target_liunian_index])
                else:
                    if target_dayun_index < len(bazi.dayun) - 1:
                        target_dayun_index += 1
                        target_dayun = bazi.dayun[target_dayun_index]
                        target_liunian_index = 0
                        dayun_list.append(target_dayun)
                        liunian_list.append(target_dayun.liunian[target_liunian_index])
                    else:
                        break
        else:
            print("未找到匹配的流年：", year)
    else:
        print("未找到匹配的大运：", year)


def __get_shishen_full_name__(ss: str):
    if ss == "官":
        return "正官"
    elif ss == "杀":
        return "七杀"
    elif ss == "财":
        return "正财"
    elif ss == "才":
        return "偏财"
    elif ss == "印":
        return "正印"
    elif ss == "枭":
        return "偏印"
    elif ss == "食":
        return "食神"
    elif ss == "伤":
        return "伤官"
    elif ss == "比":
        return "比肩"
    elif ss == "劫":
        return "劫财"
    return None
