from yixue import Configs
from yixue.Models import BaZi, ZhenDuanItem


# 格局和力量无关，只和日元有关，格局是否触发看大运流年

def run(bazi: BaZi, ss_per: {}):
    jianyi = []
    cankao = []
    __check_guan__(bazi, ss_per, jianyi, cankao)
    __check_sha__(bazi, ss_per, jianyi, cankao)
    __check_yin__(bazi, ss_per, jianyi, cankao)
    __check_xiao__(bazi, ss_per, jianyi, cankao)
    __check_shi__(bazi, ss_per, jianyi, cankao)
    __check_jie__(bazi, ss_per, jianyi, cankao)
    __check_cai__(bazi, ss_per, jianyi, cankao)
    bazi.zhenduan.geju.jianyi = jianyi
    bazi.zhenduan.geju.cankao = cankao


def __check_guan__(bazi: BaZi, ss_per: {}, jianyi: [], cankao: []):
    key1 = "官"
    name1 = "伤官冲官"
    xj = __find_xiong_ji__(bazi, key1, name1)
    if xj is not None:
        p1 = ss_per["官"]
        p2 = ss_per["伤"]
        tip = xj.tip
        name = name1
        if p1 > p2 * 2:
            tip += "但自身力量不足，可能无法冲破束缚，需要多实践，避免空谈。"
        elif p2 > p1 * 2:
            tip += "自身力量足够攻克困难或推翻权威，但要警惕因越界而导致不好的后果。"
        item = ZhenDuanItem(0, name, "，", tip)
        item.set_selected(True)
        jianyi.append(item)

    key2 = "官"
    name2 = "劫财冲官"
    xj2 = __find_xiong_ji__(bazi, key2, name2)
    if xj2 is not None:
        p1 = ss_per["官"]
        p2 = ss_per["劫"]
        tip = xj2.tip
        name = name2
        if p1 > p2 * 2:
            tip += "务必重新审视合作的合规性，如果涉及动到他人利益，对方势大可徐徐图之，不好操之过急。"
        elif p2 > p1 * 2:
            tip += "多用合同、法律保护自己，如果涉及动到他人利益，要警惕对方反扑。"
        item = ZhenDuanItem(0, name, "，", tip)
        item.set_selected(True)
        jianyi.append(item)

    key3 = "官"
    name3 = "暗合财星"
    xj3 = __find_xiong_ji__(bazi, key3, name3)
    if xj3 is not None:
        tip = xj3.tip
        name = name3
        item = ZhenDuanItem(0, name, "，", tip)
        item.set_selected(True)
        jianyi.append(item)

    key4 = "官"
    name4 = "官印相生"
    xj4 = __find_xiong_ji__(bazi, key4, name4)
    if xj4 is not None:
        tip = xj4.tip
        name = name4
        item = ZhenDuanItem(0, name, "，", tip)
        item.set_selected(True)
        jianyi.append(item)

    key5 = "官"
    name5 = "官制劫财"
    xj5 = __find_xiong_ji__(bazi, key5, name5)
    if xj5 is not None:
        tip = xj5.tip
        name = name5
        p1 = ss_per["官"]
        p2 = ss_per["劫"]
        if p1 > p2 * 2:
            tip += "八字中正官的力量很强，可以很好的保护自身财富，避开祸害。"
        elif p2 > p1 * 2:
            tip += "八字中正官的力量不足，无法完全保护自身财富，还是会遭受部分损失。"
        item = ZhenDuanItem(0, name, "，", tip)
        item.set_selected(True)
        jianyi.append(item)


def __check_sha__(bazi: BaZi, ss_per: {}, jianyi: [], cankao: []):
    key1 = "杀"
    name1 = "七杀攻身"
    xj1 = __find_xiong_ji__(bazi, key1, name1)
    if xj1 is not None:
        tip = xj1.tip
        name = name1
        p1 = ss_per["杀"]
        p2 = ss_per["比劫"]
        p3 = ss_per["食伤"]
        p4 = ss_per["印绶"]
        if p1 > (p2 + p3 + p4):
            tip += "自身力量不足，得到的帮助也少，应审视自身，做力所能及的事情。"
        else:
            if max(p2, p3, p4) == p2:
                tip += "但可以得到同伴的帮助，和同伴协力能减轻自身压力负担。"
            elif max(p2, p3, p4) == p3:
                tip += "但自身能力不弱，交际圈广，可以充分发挥自身特长把压力转换为机会。"
            elif max(p2, p3, p4) == p4:
                tip += "但容易得贵人相助，化解压力，无法解决的问题不妨向外求助。"
        item = ZhenDuanItem(0, name, "，", tip)
        item.set_selected(True)
        jianyi.append(item)

    key2 = "杀"
    name2 = "七杀劫财"
    xj2 = __find_xiong_ji__(bazi, key2, name2)
    if xj2 is not None:
        tip = xj2.tip
        name = name2
        item = ZhenDuanItem(0, name, "，", tip)
        item.set_selected(True)
        jianyi.append(item)

    key3 = "杀"
    name3 = "七杀伤官"
    xj3 = __find_xiong_ji__(bazi, key3, name3)
    if xj3 is not None:
        tip = xj3.tip
        name = name3
        p1 = ss_per["杀"]
        p2 = ss_per["伤"]
        if p1 > p2 * 2:
            tip += "八字中伤官较弱，承接事务时应客观审视，能拒绝的应学会拒绝，无法拒绝的要学会找人帮忙。"
        elif p2 > p1 * 2:
            tip += "八字中伤官不弱，自身动力很强，可以承接的住，但是会比较累自己。"
        item = ZhenDuanItem(0, name, "，", tip)
        item.set_selected(True)
        jianyi.append(item)

    key4 = "杀"
    name4 = "杀印相生"
    xj4 = __find_xiong_ji__(bazi, key4, name4)
    if xj4 is not None:
        tip = xj4.tip
        name = name4
        item = ZhenDuanItem(0, name, "，", tip)
        item.set_selected(True)
        jianyi.append(item)


def __check_yin__(bazi: BaZi, ss_per: {}, jianyi: [], cankao: []):
    key1 = "印"
    name1 = "食伤合印"
    xj1 = __find_xiong_ji__(bazi, key1, name1)
    if xj1 is not None:
        tip = xj1.tip
        name = name1
        item = ZhenDuanItem(0, name, "，", tip)
        item.set_selected(True)
        jianyi.append(item)

    key2 = "印"
    name2 = "财小印大"
    xj2 = __find_xiong_ji__(bazi, key2, name2)
    if xj2 is not None:
        tip = xj2.tip
        name = name2
        item = ZhenDuanItem(0, name, "，", tip)
        item.set_selected(True)
        jianyi.append(item)

    key3 = "印"
    name3 = "印禄相随"
    xj3 = __find_xiong_ji__(bazi, key3, name3)
    if xj3 is not None:
        tip = xj3.tip
        name = name3
        item = ZhenDuanItem(0, name, "，", tip)
        item.set_selected(True)
        jianyi.append(item)


def __check_xiao__(bazi: BaZi, ss_per: {}, jianyi: [], cankao: []):
    key1 = "枭"
    name1 = "枭神夺食"
    xj1 = __find_xiong_ji__(bazi, key1, name1)
    if xj1 is not None:
        tip = xj1.tip
        name = name1
        item = ZhenDuanItem(0, name, "，", tip)
        item.set_selected(True)
        jianyi.append(item)


def __check_shi__(bazi: BaZi, ss_per: {}, jianyi: [], cankao: []):
    key1 = "食"
    name1 = "食神制杀"
    xj1 = __find_xiong_ji__(bazi, key1, name1)
    if xj1 is not None:
        tip = xj1.tip
        name = name1
        item = ZhenDuanItem(0, name, "，", tip)
        item.set_selected(True)
        jianyi.append(item)


def __check_jie__(bazi: BaZi, ss_per: {}, jianyi: [], cankao: []):
    key1 = "劫"
    name1 = "劫财见财"
    xj1 = __find_xiong_ji__(bazi, key1, name1)
    if xj1 is not None:
        tip = xj1.tip
        name = name1
        item = ZhenDuanItem(0, name, "，", tip)
        if __check_exist__(jianyi, "官制劫财"):
            cankao.append(item)
        else:
            item.set_selected(True)
            jianyi.append(item)


def __check_cai__(bazi: BaZi, ss_per: {}, jianyi: [], cankao: []):
    keys = ["财", "才"]
    src = {}
    for ss in Configs.config_shishen_list:
        src[ss] = 0

    max_value = 0
    for key in keys:
        for xj in bazi.geju_xiongji[key]:
            name = str(xj.name).replace("合", "")
            src[name] += 1
            if src[name] > max_value:
                max_value = src[name]

    if max_value > 1:  # 如果每种财富来源都只有1个，那没什么提的必要
        for key in src:
            if src[key] == max_value:
                tip = Configs.get_value(Configs.config_zhenduan_cai, key)
                tip += __check_more_info_of_cai__(key, bazi)
                item = ZhenDuanItem(0, tip)
                item.set_selected(True)
                jianyi.append(item)


def __check_more_info_of_cai__(key: str, bazi: BaZi):
    result = ""
    riyuan = bazi.ri_gan.text
    gan_zhis = bazi.shishen_guanxi[key]
    for gz in gan_zhis:
        gns = Configs.get_value(Configs.config_gaoneng_key, gz)
        if gns is None:
            continue
        for gn in gns:
            guanxi_key = None
            if gn["guanxi"] == "穿":
                guanxi_key = "穿"
            elif gn["guanxi"] == "刑":
                guanxi_key = "刑"

            if guanxi_key is not None:
                name = str(gn["name"]).replace(gz, "").replace(guanxi_key, "")
                shishen = Configs.get_value2(Configs.config_shishen, riyuan, name)
                cai_key = guanxi_key + shishen
                hanyi = Configs.get_value(Configs.config_gaoneng_hanyi_cai, cai_key)
                if hanyi is not None:
                    result += hanyi
    if len(result) > 0:
        return "但要小心" + result
    return result


def __find_xiong_ji__(bazi: BaZi, key: str, name: str):
    item = None
    for xj in bazi.geju_xiongji[key]:
        if xj.name == name:
            item = xj
            break
    return item


def __check_exist__(items: [ZhenDuanItem], key: str):
    result = False
    for item in items:
        if key in item.content:
            result = True
            break
    return result
