from yixue import Configs
from yixue.Models import BaZi, ZhenDuanItem, PowerQiangRuo


def run(bazi: BaZi, qiang_ruo: PowerQiangRuo):
    jianyi = []
    cankao = []
    __about_rizhu__(bazi, jianyi, cankao)
    __about_men_hu__(bazi, jianyi, cankao)
    __about_jue_duan_xing_dong__(bazi, jianyi, cankao, qiang_ruo)
    __about_lu_shen__(bazi, jianyi, cankao)
    bazi.zhenduan.menhu.jianyi = jianyi
    bazi.zhenduan.menhu.cankao = cankao


def __about_rizhu__(bazi: BaZi, jianyi: [], cankao: []):
    rigan_wx = bazi.ri_gan.wu_xing
    rizhi_wx = bazi.ri_zhi.wu_xing
    v = Configs.get_value2(Configs.config_zhenduan_rizhu, rigan_wx, rizhi_wx)
    item = ZhenDuanItem(0, bazi.ri_gan.text, v)
    item.set_selected(True)
    jianyi.append(item)


def __about_men_hu__(bazi: BaZi, jianyi: [], cankao: []):
    ss = [
        bazi.nian_gan.shi_shen, bazi.yue_gan.shi_shen, bazi.shi_gan.shi_shen, bazi.shi_zhi.shi_shen
    ]

    if "财" in ss or "才" in ss:
        item = ZhenDuanItem(0, "喜欢炫耀自己拥有的东西，需注意财不露白。")
        item.tip = "要结合性格看是否成立"
        cankao.append(item)

    if "比" in ss or "劫" in ss:
        item = ZhenDuanItem(0, "喜欢彰显社会关系，人脉资源。")
        item.tip = "要结合性格看是否成立"
        cankao.append(item)


def __about_jue_duan_xing_dong__(bazi: BaZi, jianyi: [], cankao: [], qiang_ruo: PowerQiangRuo):
    # 决断力、行动力、感性理性、情商、智商、学科
    # 判断为弱的都要判断下坐支(前面计算强弱力量的时候都考虑了坐支，这里就不再一一判断了)

    if qiang_ruo.huo_ruo and qiang_ruo.shi_shang_ruo:
        item = ZhenDuanItem(0, "行动力不足，做事容易拖拉。")
        item.set_selected(True)
        jianyi.append(item)

    if qiang_ruo.jin_ruo:
        item = ZhenDuanItem(0, "决断力不足，容易踌躇不前。")
        item.set_selected(True)
        jianyi.append(item)

    if qiang_ruo.huo_wang and qiang_ruo.mu_wang:
        item = ZhenDuanItem(0, "思考问题比较感性，容易受情绪左右，文科较好。")
        item.set_selected(True)
        jianyi.append(item)
    elif qiang_ruo.jin_wang and qiang_ruo.shui_wang:
        item = ZhenDuanItem(0, "思考问题比较理性客观，有时候也容易让人觉得冷漠无情，理科较好。")
        item.set_selected(True)
        jianyi.append(item)
    elif qiang_ruo.tu_wang:
        item = ZhenDuanItem(0, "善于钻研，具有艺术天赋。")
        item.set_selected(True)
        jianyi.append(item)

    if qiang_ruo.huo_wang and qiang_ruo.shi_shang_wang:
        item = ZhenDuanItem(0, "情商高。")
        item.set_selected(True)
        jianyi.append(item)

    if qiang_ruo.shui_wang:
        item = ZhenDuanItem(0, "极具智慧。")
        item.set_selected(True)
        jianyi.append(item)


def __about_lu_shen__(bazi: BaZi, jianyi: [], cankao: []):
    for index, dz in enumerate(bazi.all_di_zhis()):
        if "禄神" in dz.shenshas or "半禄" in dz.shenshas:
            s = None
            if index == 0:
                s = "祖上有积累，物质基础不错。"
                if dz.has_guanxi_in_gaonengs(["破", "穿"]):
                    s += "但是有破败之相，无法完全得到。"
                elif dz.has_guanxi_in_gaonengs(["冲", "刑"]):
                    s += "但是纷争多，牵扯不断。"
            elif index == 1:
                s = "家境不错，父母提供了较好的物质基础。"
                if dz.has_guanxi_in_gaonengs(["破", "穿"]):
                    s += "但是有破败之相，无法完全得到。"
                elif dz.has_guanxi_in_gaonengs(["冲", "刑"]):
                    s += "但是纷争多，牵扯不断。"
            elif index == 2:
                s = "自身有很好的赚钱能力，也喜欢为自己花钱，爱自己更多一些。"
            elif index == 3:
                s = "子女孝顺，晚年不愁。"

            if s is not None:
                item = ZhenDuanItem(0, s)
                item.set_selected(True)
                jianyi.append(item)
