from yixue import Configs
from yixue.Models import BaZi, ZhenDuanItem, PowerQiangRuo, SiZhu, XiongJi


def run(bazi: BaZi, qiang_ruo: PowerQiangRuo):
    jianyi = []
    cankao = []
    __check_menhu_zuozhi__(bazi, jianyi, cankao, qiang_ruo)
    __check_tao_hua__(bazi, jianyi, cankao)
    __check_rizhi__(bazi, jianyi, cankao)
    __check_others__(bazi, jianyi, cankao)
    bazi.zhenduan.qinggan.jianyi = jianyi
    bazi.zhenduan.qinggan.cankao = cankao


def __check_menhu_zuozhi__(bazi: BaZi, jianyi: [], cankao: [], qiang_ruo: PowerQiangRuo):
    menhu_wuxing = [
        bazi.nian_gan.wu_xing, bazi.yue_gan.wu_xing, bazi.ri_gan.wu_xing, bazi.shi_gan.wu_xing, bazi.shi_zhi.wu_xing
    ]
    jiali_shishen = [
        bazi.ri_gan.shi_shen, bazi.shi_gan.shi_shen, bazi.ri_zhi.shi_shen, bazi.shi_zhi.shi_shen
    ]

    if "金" in menhu_wuxing and "水" in menhu_wuxing:
        item = ZhenDuanItem(0, "金水挂门户，长的好看，皮肤白皙。")
        item.set_selected(True)
        jianyi.append(item)

    if bazi.shi_gan.shi_shen in ["官", "杀"]:
        if not bazi.is_man:
            item = ZhenDuanItem(0, "官杀星挂门外，不是太重视配偶。")
            cankao.append(item)

    if not bazi.is_man:

        if __has_geju__(bazi.geju_xiongji["官"], "伤官冲官"):
            item = ZhenDuanItem(0, "伤官冲官，容易与配偶争吵。")
            item.set_selected(True)
            jianyi.append(item)

        if __has_geju__(bazi.geju_xiongji["杀"], "七杀攻身"):
            item = ZhenDuanItem(0, "七杀攻身，容易遇到不合适的人，情路坎坷。")
            item.set_selected(True)
            jianyi.append(item)

        if qiang_ruo.guan_sha_ruo:
            item = ZhenDuanItem(0, "官杀弱，不太看得上男人，容易晚婚或单身。")
            item.set_selected(True)
            jianyi.append(item)
        elif qiang_ruo.guan_sha_guo_wang:
            item = ZhenDuanItem(0, "官杀旺，容易挑花眼，导致晚婚或单身。")
            item.set_selected(True)
            jianyi.append(item)

        if bazi.ri_zhi.shi_shen == "杀":
            item = ZhenDuanItem(0, "坐七杀，情路多坎坷，容易遇到不合适的人。")
            item.set_selected(True)
            jianyi.append(item)
        elif bazi.ri_zhi.shi_shen in ["食", "伤"]:
            item = ZhenDuanItem(0, "坐食伤，容易冲撞配偶，自身表达欲过于旺盛容易压制配偶的家庭地位，对夫妻感情不利。")
            item.set_selected(True)
            jianyi.append(item)
        elif bazi.ri_zhi.shi_shen in ["印", "枭"]:
            item = ZhenDuanItem(0, "坐印绶，容易招惹风言风语，对自身口碑不利。")
            item.set_selected(True)
            jianyi.append(item)
    else:
        if "官" in jiali_shishen or "杀" in jiali_shishen:
            item = ZhenDuanItem(0, "官杀家中坐，容易大男子主义。")
            item.set_selected(True)
            jianyi.append(item)

        if qiang_ruo.cai_xing_ruo:
            item = ZhenDuanItem(0, "财星弱，组织家庭的意愿不强，容易晚婚或单身。")
            item.set_selected(True)
            jianyi.append(item)
        elif qiang_ruo.cai_xing_guo_wang:
            item = ZhenDuanItem(0, "财星旺，谈了很多个但定不下来，容易晚婚或单身。")
            item.set_selected(True)
            jianyi.append(item)

        if bazi.ri_zhi.shi_shen in ["官", "杀"]:
            item = ZhenDuanItem(0, "坐官杀，容易被配偶管着，家庭中配偶更强势。")
            item.set_selected(True)
            jianyi.append(item)
        elif bazi.ri_zhi.shi_shen in ["食", "伤"]:
            item = ZhenDuanItem(0,
                                "坐食伤，喜欢照顾别人，容易找比自己年纪小的伴侣。容易把自身想法强加给别人，在子女教育上容易无意识的限制了子女的发展方向。")
            item.set_selected(True)
            jianyi.append(item)
        elif bazi.ri_zhi.shi_shen in ["比", "劫"]:
            item = ZhenDuanItem(0, "坐比劫，重视朋友多过重视配偶，容易引起配偶不满，对夫妻感情不利。")
            item.set_selected(True)
            jianyi.append(item)
        elif bazi.ri_zhi.shi_shen in ["印", "枭"]:
            item = ZhenDuanItem(0, "坐印绶，依赖性强，喜欢被照顾，容易找比自己年长的配偶。")
            item.set_selected(True)
            jianyi.append(item)
        elif bazi.ri_zhi.shi_shen in ["财", "才"]:
            item = ZhenDuanItem(0, "坐财星，重视配偶，对自己拥有的东西都看的很重。")
            item.set_selected(True)
            jianyi.append(item)


def __check_tao_hua__(bazi: BaZi, jianyi: [], cankao: []):
    sheng_wang = False
    jian_shui = False
    shi_zhi = False
    shi_zhi_shang_guan = False
    nian_yue_zhu = False
    ri_zhu = False
    qi_sha_tong_zhu = False
    lu_shen_tong_zhu = False
    yang_ren_tong_zhu = False
    kong_wang_tong_zhu = False
    bei_xing = False
    zheng_guan_yin_tong_zhu = False
    shi_shen_tong_zhu = False
    shang_guan_tong_zhu = False
    jie_cai_tong_zhu = False
    pian_yin_tong_zhu = False
    bi_jian_tong_zhu = False
    for dz in bazi.all_di_zhis():
        for sa in dz.shenshas:
            if sa != "桃花":
                continue
            if dz.zhang_sheng_zhu in ["生", "沐", "冠", "临", "帝"]:
                sheng_wang = True
            if dz.wu_xing == "水":
                jian_shui = True
            if dz.wei_zhi == Configs.const_shi_zhi:
                shi_zhi = True
                if dz.shi_shen == "伤":
                    shi_zhi_shang_guan = True
            if dz.wei_zhi in [Configs.const_nian_zhi, Configs.const_yue_zhi]:
                nian_yue_zhu = True
            if dz.wei_zhi == Configs.const_ri_zhi:
                ri_zhu = True
            if dz.shi_shen == "杀":
                qi_sha_tong_zhu = True
            if __has_shensha__(dz, ["禄神", "半禄"]):
                lu_shen_tong_zhu = True
            if __has_shensha__(dz, ["羊刃"]):
                yang_ren_tong_zhu = True
            if __has_shensha__(dz, ["空亡"]):  # 神煞那边未判断空亡
                kong_wang_tong_zhu = True
            if __has_gaoneng__(dz, ["刑"]):
                bei_xing = True
            if dz.shi_shen in ["官", "印"]:
                zheng_guan_yin_tong_zhu = True
            if dz.shi_shen == "食":
                shi_shen_tong_zhu = True
            if dz.shi_shen == "伤":
                shang_guan_tong_zhu = True
            if dz.shi_shen == "劫":
                jie_cai_tong_zhu = True
            if dz.shi_shen == "枭":
                pian_yin_tong_zhu = True
            if dz.shi_shen == "比":
                bi_jian_tong_zhu = True

    if sheng_wang is True:
        if bazi.is_man:
            item = ZhenDuanItem(0, "桃花落生旺之地，姿容俊美，异性缘佳。")
            item.set_selected(True)
            jianyi.append(item)
        else:
            item = ZhenDuanItem(0, "桃花落生旺之地，风情万种，异性缘佳。")
            item.set_selected(True)
            jianyi.append(item)

    if jian_shui:
        item = ZhenDuanItem(0, "桃花见水，生理欲望强，容易两性关系混乱。")
        cankao.append(item)

    if shi_zhi:
        item = ZhenDuanItem(0, "墙外桃花，易犯桃花劫。")
        cankao.append(item)
        if shi_zhi_shang_guan:
            item = ZhenDuanItem(0, "容易多个配偶，婚姻不美满。")
            cankao.append(item)
    if nian_yue_zhu:
        item = ZhenDuanItem(0, "内桃花，夫妻恩爱。")
        item.set_selected(True)
        jianyi.append(item)

    if ri_zhu:
        item = ZhenDuanItem(0, "日柱桃花，夫妻纠纷多，容易吵架。")
        item.set_selected(True)
        jianyi.append(item)

    if qi_sha_tong_zhu:
        content = "桃花遇七杀，情人多，欲望强。"
        if bazi.is_man:
            content += "易得女贵人相助，容易因欲望犯罪。"
        else:
            content += "易产生情色交易。"
            if bazi.tong_dang * 2 < bazi.yi_dang:
                content += "身弱，容易被迫堕入风尘。"
        item = ZhenDuanItem(0, content)
        cankao.append(item)

    if lu_shen_tong_zhu:
        item = ZhenDuanItem(0, "桃花遇禄神，异性缘极佳。")
        item.set_selected(True)
        jianyi.append(item)

    if yang_ren_tong_zhu:
        item = ZhenDuanItem(0, "桃花遇羊刃，情感上容易招惹风波。")
        item.set_selected(True)
        jianyi.append(item)

    if kong_wang_tong_zhu:
        item = ZhenDuanItem(0, "桃花遇空亡，人缘欠佳，一生多苦情。")
        item.set_selected(True)
        jianyi.append(item)

    if bei_xing:
        item = ZhenDuanItem(0, "桃花被刑，容易婚变。")
        cankao.append(item)

    if zheng_guan_yin_tong_zhu:
        item = ZhenDuanItem(0, "正桃花，有自控力，约束力强，不滥情。")
        item.set_selected(True)
        jianyi.append(item)

    if shi_shen_tong_zhu:
        item = ZhenDuanItem(0, "桃花遇食神，会欲望转化为文学、艺术才华。")
        item.set_selected(True)
        jianyi.append(item)

    if shang_guan_tong_zhu:
        item = ZhenDuanItem(0, "桃花遇伤官，欲望强，容易喜新厌旧，自恃才貌，追求时髦，对感情不在乎。")
        cankao.append(item)

    if jie_cai_tong_zhu:
        item = ZhenDuanItem(0, "桃花遇劫财，容易横刀夺爱，敢爱敢恨，争风吃醋。")
        cankao.append(item)

    if pian_yin_tong_zhu:
        item = ZhenDuanItem(0, "桃花遇偏印，生理欲望强，不走寻常路。")
        cankao.append(item)

    if bi_jian_tong_zhu:
        item = ZhenDuanItem(0, "桃花遇比肩，容易孤芳自赏，单身主义。")
        item.set_selected(True)
        jianyi.append(item)


def __check_rizhi__(bazi: BaZi, jianyi: [], cankao: []):
    if __has_gaoneng__(bazi.ri_zhi, ["穿", "破"]):
        content = "配偶宫相害相破，夫妻情感容易破裂。"
        if __has_gaoneng__(bazi.ri_zhi, ["合", "暗合"]):
            content += "容易焦灼着，不一定会彻底分开。"
        item = ZhenDuanItem(0, content)
        cankao.append(item)

    if __has_gaoneng__(bazi.ri_zhi, ["刑"]):
        item = ZhenDuanItem(0, "配偶宫被刑，夫妻情感不好，容易互相伤害，但又不会分开，一直吊着。")
        cankao.append(item)

    an_he_list = __find_gaoneng__(bazi.ri_zhi, ["暗合"])
    if len(an_he_list) > 0:
        an_he = an_he_list[0]
        if bazi.is_man:
            if an_he.shi_shen2 in ["财", "才"]:
                item = ZhenDuanItem(0, "配偶宫暗合财星，情感中可能存在第三者。")
                cankao.append(item)
            else:
                zhi = __get_zhi_by_weizhi__(bazi, an_he.wei_zhi2)
                if __has_shishen_in_canggan__(zhi, ["财", "才"]):
                    item = ZhenDuanItem(0, "配偶宫暗合财星(藏干)，情感中可能存在第三者。")
                    cankao.append(item)

        else:
            if an_he.shi_shen2 in ["官", "杀"]:
                item = ZhenDuanItem(0, "配偶宫暗合官杀，情感中可能存在第三者。")
                cankao.append(item)
            elif an_he.shi_shen2 in ["财", "才"]:
                item = ZhenDuanItem(0, "配偶宫暗合财星，情感中可能存在第三者。")
                cankao.append(item)
            else:
                zhi = __get_zhi_by_weizhi__(bazi, an_he.wei_zhi2)
                if __has_shishen_in_canggan__(zhi, ["官", "杀"]):
                    item = ZhenDuanItem(0, "配偶宫暗合官杀(藏干)，情感中可能存在第三者。")
                    cankao.append(item)
                elif __has_shishen_in_canggan__(zhi, ["财", "才"]):
                    item = ZhenDuanItem(0, "配偶宫暗合财星(藏干)，情感中可能存在第三者。")
                    cankao.append(item)


def __check_others__(bazi: BaZi, jianyi: [], cankao: []):
    # 本来应该是独官被穿，这里延伸为正官被穿，不考虑独官的情况
    target_dayun = None
    for dayun in bazi.dayun:
        if dayun.start_age in range(10, 20):
            target_dayun = dayun
            break

    if target_dayun is not None:
        ct = 0
        has_guan = __has_guan_in_dizhi__(bazi)
        for liunian in target_dayun.liunian:
            if has_guan:
                chuan_gan = __count_chuan_guan__(liunian.gan_zhu)
                chuan_zhi = __count_chuan_guan__(liunian.zhi_zhu)
                ct += chuan_gan + chuan_zhi
            else:
                pass
        if ct > 0:
            per = 30 * ct
            if per > 100:
                per = 100
            item = ZhenDuanItem(0, "正官被穿，三观容易被改变。")
            item.tip = str(per) + "%"
            cankao.append(item)


def __has_shensha__(sz: SiZhu, names: [str]):
    result = False
    for sa in sz.shenshas:
        if sa in names:
            result = True
            break
    return result


def __has_gaoneng__(sz: SiZhu, guanxis: [str]):
    result = False
    for gn in sz.gaonengs:
        if gn.guanxi in guanxis:
            result = True
            break
    return result


def __find_gaoneng__(sz: SiZhu, guanxis: [str]):
    result = []
    for gn in sz.gaonengs:
        if gn.guanxi in guanxis:
            result.append(gn)
    return result


def __get_zhi_by_weizhi__(bazi: BaZi, weizhi: int):
    result = None
    if weizhi == Configs.const_nian_zhi:
        result = bazi.nian_zhi
    elif weizhi == Configs.const_yue_zhi:
        result = bazi.yue_zhi
    elif weizhi == Configs.const_ri_zhi:
        result = bazi.ri_zhi
    elif weizhi == Configs.const_shi_zhi:
        result = bazi.shi_zhi
    return result


def __has_shishen_in_canggan__(zhi: SiZhu, shishens: [str]):
    result = False
    if zhi is None:
        return result
    ary = []
    if zhi.gan1_shi_shen is not None:
        ary.append(zhi.gan1_shi_shen)
    if zhi.gan2_shi_shen is not None:
        ary.append(zhi.gan2_shi_shen)
    if zhi.gan3_shi_shen is not None:
        ary.append(zhi.gan3_shi_shen)
    for ss in shishens:
        if ss in ary:
            result = True
            break
    return result


def __has_geju__(src: [XiongJi], key: str):
    result = False
    for dt in src:
        if dt.name == key:
            result = True
            break
    return result


def __has_guan_in_dizhi__(bazi: BaZi):
    ary = [bazi.nian_zhi.shi_shen, bazi.yue_zhi.shi_shen, bazi.ri_zhi.shi_shen, bazi.shi_zhi.shi_shen]
    return "官" in ary


def __count_chuan_guan__(sz: SiZhu):
    ct = 0
    for gn in sz.gaonengs:
        if gn.guanxi == "穿":
            if gn.shi_shen2 in ["官"] and gn.wei_zhi2 < 10:
                ct += 1
    return ct
