from yixue import Configs
from yixue.Models import BaZi, ZhenDuanItem


def about_wuxing(bazi: BaZi, wx_per: {}):
    jianyi_wuxing = []
    cankao_wuxing = []
    __check_wuxing__(wx_per, jianyi_wuxing, cankao_wuxing, bazi.ri_zhi.wu_xing)
    cankao_wuxing.sort(key=lambda item: item.order)
    bazi.zhenduan.wuxing.jianyi = jianyi_wuxing
    bazi.zhenduan.wuxing.cankao = cankao_wuxing


def about_shi_shen(bazi: BaZi, ss_per: {}):
    jianyi_shishen = []
    cankao_shishen = []
    __check_shi_shen__(ss_per, jianyi_shishen, cankao_shishen, bazi.ri_zhi.shi_shen, bazi.is_man)
    # cankao_shishen.sort(key=lambda item: item.order)
    bazi.zhenduan.shishen.jianyi = jianyi_shishen
    bazi.zhenduan.shishen.cankao = cankao_shishen


def about_zuozhi(bazi: BaZi):
    jianyi = []
    cankao = []
    zuozhi_shishen = bazi.ri_zhi.shi_shen
    full_zuozhi = __get_shishen_class_name__(zuozhi_shishen)

    v_full = Configs.get_value(Configs.config_zhenduan_zuozhi, full_zuozhi)
    item = ZhenDuanItem(0, "坐支", full_zuozhi, "，", v_full)
    item.set_selected(True)
    jianyi.append(item)

    if zuozhi_shishen == "财":
        item = ZhenDuanItem(0, "财富观念比较稳健，较少涉及风险领域。")
        item.set_selected(True)
        jianyi.append(item)
    elif zuozhi_shishen == "才":
        item = ZhenDuanItem(0, "财富观念上比较激进，有风险投资倾向，喜欢赚块钱，容易离开家乡发展。")
        item.set_selected(True)
        jianyi.append(item)
    elif zuozhi_shishen == "印":
        item = ZhenDuanItem(0, "重视口碑，自身内核强，稳重，遇事不慌，学习的东西容易转化为成果。")
        item.set_selected(True)
        jianyi.append(item)
    elif zuozhi_shishen == "枭":
        item = ZhenDuanItem(0, "对信息、氛围敏感，容易沉迷一些事物，喜欢探索研究。")
        item.set_selected(True)
        jianyi.append(item)
    elif zuozhi_shishen == "食":
        item = ZhenDuanItem(0,
                            "想的多做的少，喜欢自由不喜欢被束缚。看破不说破，大智若愚，具有战略思维，有格局。喜欢钻牛角尖，容易想太多而精神衰弱。")
        item.set_selected(True)
        jianyi.append(item)
    elif zuozhi_shishen == "伤":
        item = ZhenDuanItem(0, "做的多想的少，功利性强，胜负欲旺，社交能力强，容易冲撞长辈、领导。")
        item.set_selected(True)
        jianyi.append(item)
    elif zuozhi_shishen == "比":
        item = ZhenDuanItem(0, "主观性强，果断冷静。具备个人魅力，领导力强，与人合作多以自身为主导，多亲力亲为。")
        item.set_selected(True)
        jianyi.append(item)
    elif zuozhi_shishen == "劫":
        item = ZhenDuanItem(0, "喜欢投机冒险，点子很多，重视人脉关系，多与人合作分享利益，较多依赖他人的资源和能力。")
        item.set_selected(True)
        jianyi.append(item)

    bazi.zhenduan.zuozhi.jianyi = jianyi
    bazi.zhenduan.zuozhi.cankao = cankao


def __check_shi_shen__(percentages: [], jianyi: [], cankao: [], zuozhi_shishen: str, is_man: bool):
    keys = ["官杀", "财星", "印绶", "食伤", "比劫"]
    for key in keys:
        if percentages[key] >= 50:
            item = ZhenDuanItem(0, key, "过旺，", __desc__shishen__(key, "旺"),
                                "但容易", __desc__shishen__(key, "过旺"))
            item.set_selected(True)
            jianyi.append(item)
            __check_single_shishen__(key, jianyi, cankao, percentages, zuozhi_shishen)

        elif 37.5 < percentages[key] < 50:
            item = ZhenDuanItem(1, key, "偏旺，", __desc__shishen__(key, "旺"),
                                "但容易", __desc__shishen__(key, "过旺"))
            cankao.append(item)
            __check_single_shishen__(key, jianyi, cankao, percentages, zuozhi_shishen, True)
        elif 18 < percentages[key] <= 37.5:
            item = ZhenDuanItem(0, key, "旺，", __desc__shishen__(key, "旺"))
            cankao.append(item)
            __check_single_shishen__(key, jianyi, cankao, percentages, zuozhi_shishen, True)
        elif 10 < percentages[key] <= 18:
            if __get_shishen_class_name__(zuozhi_shishen) != key:  # 坐支不算弱
                item = ZhenDuanItem(2, key, "偏弱，", __desc__shishen__(key, "衰"))
                cankao.append(item)
                __check_single_shishen__(key, jianyi, cankao, percentages, zuozhi_shishen, True)
        elif 0 <= percentages[key] <= 10:
            if __get_shishen_class_name__(zuozhi_shishen) != key:  # 坐支不算弱
                item = ZhenDuanItem(0, key, "弱，", __desc__shishen__(key, "衰"))
                item.set_selected(True)
                jianyi.append(item)


def __check_single_shishen__(key: str, jianyi: [], cankao: [], percentages: [], zuozhi_shishen: str,
                             all_cankao: bool = False):
    names = __get_single_shishens__(key)
    if names is None:
        return
    for key in names:
        desc_name = __get_shishen_full_name__(key)
        if percentages[key] >= 50:
            item = ZhenDuanItem(0, "以", desc_name, "力量为主，", __desc__shishen__(key, "旺"),
                                "但容易", __desc__shishen__(key, "过旺"))
            if all_cankao:
                cankao.append(item)
            else:
                item.set_selected(True)
                jianyi.append(item)
        elif 37.5 < percentages[key] < 50:
            item = ZhenDuanItem(0, "以", desc_name, "力量为主，", __desc__shishen__(key, "旺"),
                                "但容易", __desc__shishen__(key, "过旺"))
            if all_cankao:
                cankao.append(item)
            else:
                item.set_selected(True)
                jianyi.append(item)
        elif 18 < percentages[key] <= 37.5:
            item = ZhenDuanItem(1, "以", desc_name, "力量为主，", __desc__shishen__(key, "旺"))
            cankao.append(item)
        elif 10 < percentages[key] <= 18:
            if zuozhi_shishen != key:  # 坐支不算弱
                item = ZhenDuanItem(2, desc_name, "偏弱，", __desc__shishen__(key, "衰"))
                cankao.append(item)
        elif 0 <= percentages[key] <= 10:
            if zuozhi_shishen != key:  # 坐支不算弱
                item = ZhenDuanItem(0, desc_name, "弱，", __desc__shishen__(key, "衰"))
                if all_cankao:
                    cankao.append(item)
                else:
                    item.set_selected(True)
                    jianyi.append(item)


def __check_wuxing__(percentages: [], jianyi: [], cankao: [], zuozhi_wuxing: str):
    for wx in Configs.config_wuxing_list:
        if percentages[wx] >= 50:
            item = ZhenDuanItem(0, wx, "过旺，性格", __desc__wuxing__(wx, "旺"),
                                "但容易", __desc__wuxing__(wx, "过旺"))
            item.set_selected(True)
            jianyi.append(item)
        elif 37.5 < percentages[wx] < 50:
            item = ZhenDuanItem(1, wx, "偏旺，性格", __desc__wuxing__(wx, "旺"),
                                "但容易", __desc__wuxing__(wx, "过旺"))
            cankao.append(item)
        elif 18 < percentages[wx] <= 37.5:
            item = ZhenDuanItem(0, wx, "旺，性格", __desc__wuxing__(wx, "旺"))
            cankao.append(item)
        elif 10 < percentages[wx] <= 18:
            if zuozhi_wuxing != wx:  # 坐支不算弱
                item = ZhenDuanItem(2, wx, "偏弱，容易", __desc__wuxing__(wx, "衰"))
                cankao.append(item)
        elif 0 <= percentages[wx] <= 10:
            if zuozhi_wuxing != wx:  # 坐支不算弱
                item = ZhenDuanItem(0, wx, "弱，容易", __desc__wuxing__(wx, "衰"))
                item.set_selected(True)
                jianyi.append(item)


def __get_shishen_full_name__(ss: str):
    if ss == "官":
        return "正官"
    elif ss == "杀":
        return "七杀"
    elif ss == "财":
        return "正财"
    elif ss == "才":
        return "偏财"
    elif ss == "印":
        return "正印"
    elif ss == "枭":
        return "偏印"
    elif ss == "食":
        return "食神"
    elif ss == "伤":
        return "伤官"
    elif ss == "比":
        return "比肩"
    elif ss == "劫":
        return "劫财"
    return None


def __get_single_shishens__(full_name: str):
    if full_name == "官杀":
        return ["官", "杀"]
    elif full_name == "财星":
        return ["财", "才"]
    elif full_name == "印绶":
        return ["印", "枭"]
    elif full_name == "食伤":
        return ["食", "伤"]
    elif full_name == "比劫":
        return ["比", "劫"]
    return None


def __get_shishen_class_name__(ss: str):
    if ss in ["官", "杀"]:
        return "官杀"
    if ss in ["财", "才"]:
        return "财星"
    if ss in ["印", "枭"]:
        return "印绶"
    if ss in ["食", "伤"]:
        return "食伤"
    if ss in ["比", "劫"]:
        return "比劫"
    return ""


def __desc__wuxing__(wx: str, state: str):
    return Configs.get_value2(Configs.config_zhenduan_wuxing, wx, state)


def __desc__shishen__(ss: str, state: str):
    return Configs.get_value2(Configs.config_zhenduan_shishen, ss, state)
