import datetime

from yixue.Models import BaZi, ZhenDuanItem


def run(bazi: BaZi, wx_per: {}, ss_per: {}):
    jianyi = []
    cankao = []
    __about_wan_hun__(bazi, ss_per, jianyi, cankao)
    __about_duo_hun__(bazi, jianyi, cankao)
    __about_others__(bazi, wx_per, jianyi, cankao)
    bazi.zhenduan.yinyuan.jianyi = jianyi
    bazi.zhenduan.yinyuan.cankao = cankao


def __about_wan_hun__(bazi: BaZi, ss_per: {}, jianyi: [], cankao: []):
    if bazi.is_man:
        if ss_per["劫"] >= 37.5:
            item = ZhenDuanItem(0, "劫财过旺，容易晚婚。")
            item.set_selected(True)
            jianyi.append(item)
    else:
        if ss_per["伤"] >= 37.5:
            item = ZhenDuanItem(0, "伤官过旺，容易晚婚。")
            item.set_selected(True)
            jianyi.append(item)

    if bazi.ri_zhi.is_muku is True and bazi.ri_zhi.is_muku_open is False:
        item = ZhenDuanItem(0, "婚姻宫坐库不开，容易晚婚。")
        item.set_selected(True)
        jianyi.append(item)

    for dayun in bazi.dayun:
        if dayun.start_age in range(20, 30):
            if dayun.gan_zhu.shi_shen in ["食", "伤"] or dayun.zhi_zhu.shi_shen in ["食", "伤"]:
                item = ZhenDuanItem(0, "在适婚年龄追求自由，容易晚婚。")
                item.set_selected(True)
                jianyi.append(item)
            break


def __about_duo_hun__(bazi: BaZi, jianyi: [], cankao: []):
    if __is_fuyin__(bazi):
        item = ZhenDuanItem(0, "婚姻宫伏吟，容易多婚。")
        cankao.append(item)

    if bazi.is_man:
        if "羊刃" in bazi.ri_zhi.shenshas:
            item = ZhenDuanItem(0, "坐支羊刃，容易多婚。")
            cankao.append(item)
    else:
        if bazi.ri_zhi.shi_shen == "伤":
            item = ZhenDuanItem(0, "坐支伤官，容易多婚。")
            cankao.append(item)


def __about_others__(bazi: BaZi, wx_per: {}, jianyi: [], cankao: []):
    if bazi.is_man:
        shishen_list = [bazi.nian_gan.shi_shen, bazi.nian_zhi.shi_shen, bazi.yue_gan.shi_shen, bazi.yue_zhi.shi_shen,
                        bazi.ri_gan.shi_shen, bazi.ri_zhi.shi_shen, bazi.shi_gan.shi_shen, bazi.shi_zhi.shi_shen]

        if "劫" in shishen_list:
            if "财" in shishen_list or "才" in shishen_list:
                # 男命，劫财见财，配偶容易被劫走，被朋友抢夺。因此，金木旺就会家暴，水火旺就吵架。
                content = "容易因第三者引发情感问题，"
                if wx_per["火"] >= 25 and wx_per["水"] >= 25:
                    content += "陷入无休止的争吵置气。"
                elif wx_per["金"] >= 25 and wx_per["木"] >= 25:
                    content += "严重的可能引起家暴。"
                item = ZhenDuanItem(0, content)
                cankao.append(item)
    else:
        if bazi.ri_zhi.shi_shen == "杀":
            content = "容易遇渣男，情感不顺。"
            if wx_per["金"] >= 25 and wx_per["木"] >= 25:
                content += "婚姻不好，甚至遭受家暴。"
            item = ZhenDuanItem(0, content)
            cankao.append(item)

    year = datetime.datetime.now().year
    found = False
    for dayun in bazi.dayun:
        if dayun.is_dayun:
            if dayun.start_year <= year and year <= dayun.end_year:
                for liunian in dayun.liunian:
                    if liunian.yinyuan_level > 0:
                        item = ZhenDuanItem(0, "最近的姻缘在", str(liunian.year), "，好好把握机会。")
                        cankao.append(item)
                        found = True
                        break
                if found:
                    break


def __is_fuyin__(bazi: BaZi):
    result = False
    if bazi.yue_gan.text == bazi.ri_gan.text:
        if bazi.yue_zhi.text == bazi.ri_zhi.text:
            result = True
    if bazi.shi_gan.text == bazi.ri_gan.text:
        if bazi.shi_zhi.text == bazi.ri_zhi.text:
            result = True
    return result
